#version 330

layout(points) in;
layout (triangle_strip, max_vertices=8) out;

in vec3 out_color[1];

out VertexData {
	vec3 color;
} VertexOut;

uniform float line_semi_length;
uniform float line_semi_thickness;
uniform float ratio;

#define coeff_mul 0.007
void main(void)
{
	VertexOut.color = out_color[0];
	
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x+=line_semi_length-line_semi_thickness;
	gl_Position.y+=(line_semi_length+line_semi_thickness);//*ratio;
	EmitVertex();
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x+=line_semi_length+line_semi_thickness;
	gl_Position.y+=(line_semi_length-line_semi_thickness);//*ratio;
	EmitVertex();
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x-=line_semi_length+line_semi_thickness;
	gl_Position.y-=(line_semi_length-line_semi_thickness);//*ratio;
	EmitVertex();
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x-=line_semi_length-line_semi_thickness;
	gl_Position.y-=(line_semi_length+line_semi_thickness);//*ratio;
	EmitVertex();
	
    EndPrimitive();
	
	
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x-=line_semi_length-line_semi_thickness;
	gl_Position.y+=(line_semi_length+line_semi_thickness);//*ratio;
	EmitVertex();
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x-=line_semi_length+line_semi_thickness;
	gl_Position.y+=(line_semi_length-line_semi_thickness);//*ratio;
	EmitVertex();
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x+=line_semi_length+line_semi_thickness;
	gl_Position.y-=(line_semi_length-line_semi_thickness);//*ratio;
	EmitVertex();
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x+=line_semi_length-line_semi_thickness;
	gl_Position.y-=(line_semi_length+line_semi_thickness);//*ratio;
	EmitVertex();

    EndPrimitive();
}


