#ifndef SHADER_CLASS_HEADER
#define SHADER_CLASS_HEADER

#pragma once
#include<initializer_list>

#include"util_define.h"

#include"texture_fbo.h"

#define BUFFER_OFFSET(i)   ((char *)NULL + (i))
//template<typename T>
////struct function_trait<T>;
//struct function_trait : public function_trait<decltype(&T::operator())>{};
//template<typename R, typename L, typename... Args>
//struct function_trait<const std::function<R (L::*) (Args...)>&>:public function_trait<const std::function<R (Args...)>&>{};
//template<typename R, typename... Args>
//struct function_trait<const std::function<R (Args...)>&>
//{
//	static const size_t nargs = sizeof...(Args);
//	typedef R return_type;
//	typedef typename std::function<R(Args...)> function_type;
//	template<size_t i>
//	struct Arg
//	{
//		typedef typename std::tuple_element<i,std::tuple<Args...>>::type type;
//	};
//};
//class prototype
//{
//public:
//	virtual void get_name(std::string& name){name = "default_name";};
//	template<typename T>
//	virtual void get_data(std::vector<T>& data);
//}
class VBO
{
	private:
	std::map<std::string, std::pair<GLuint,GLuint>> group_to_location_and_nb_elem;//if(vector<vec3>, nb_elem = 3
	std::vector<unsigned char*> vptr_data_tmp;
	std::vector<std::size_t> v_size_tmp;
	GLuint	location;


	//std::tuple<
	//	std::vector<std::function<void (std::string&, std::vector<int>&)>>,
	//	std::vector<std::function<void (std::string&, std::vector<float>&)>>,
	//	std::vector<std::function<void (std::string&, std::vector<glm::vec2>&)>>,
	//	std::vector<std::function<void (std::string&, std::vector<glm::vec3>&)>>,
	//	std::vector<std::function<void (std::string&, std::vector<glm::vec4>&)>>
	//		> data;
	GLuint vbo;
	GLuint buffer_type;
	GLuint buffer_type_draw;
	public:
	//VBO():location(0),vbo(0),buffer_type(GL_ARRAY_BUFFER){}
	VBO(GLuint type = GL_ARRAY_BUFFER, GLuint type_draw = GL_STATIC_DRAW):location(0),vbo(0),buffer_type(type),buffer_type_draw(type_draw){}
	~VBO()
	{
		clear_vbo();
		GLuint errCode;
		if ((errCode = glGetError()) != GL_NO_ERROR) {
			std::cerr << "VBO_DESTRUCTOR_ERROR error: " << errCode << std::endl;
		}
	}
	void clear_vbo()
	{
		if(vbo)
		{
			glDeleteBuffers(1,&vbo);
			vbo=0;
		}
		v_size_tmp.clear();
		std::for_each(vptr_data_tmp.begin(),vptr_data_tmp.end(),[](unsigned char* ptr){delete[] ptr;});
		vptr_data_tmp.clear();
		v_size_tmp.clear();
		group_to_location_and_nb_elem.clear();
		location=0;
	}
	void set_buffer_type(GLuint type)
	{
		buffer_type = type;
	}
	void set_buffer_type_draw(GLuint type)
	{
		buffer_type_draw = type;
	}
//	void create_vbo_tmp(std::map<std::string, std::pair<GLuint,GLuint>>&,
//		std::vector<std::unique_ptr<unsigned char>>&,
//		std::vector<size_t>&, size_t&)
//	{
//	}
//template<typename T, typename... Args>
//void create_vbo_tmp( std::map<std::string, std::pair<GLuint,GLuint>>& group_to_location_and_nb_elem,
//		std::vector<std::unique_ptr<unsigned char>>& vertex,
//		std::vector<size_t>& vsize, size_t&	location,
//		const T& v_fn,	const Args&... args)
//{
//		size_t tmp_size;
//		std::string tmp_name;
//		std::unique_ptr<unsigned char> uptr;
//			for(const auto& fn : v_fn)
//			{
////				typename function_trait<decltype(*v_fn.begin())>::return_type rr;
//				//typename function_trait<decltype(*v_fn.begin())>::Arg<1>::type vect;
//				//typename function_trait<decltype(*v_fn.begin())>::Arg::type vect;
//				typename std::remove_reference<typename function_trait<decltype(*v_fn.begin())>::template Arg<1>::type>::type vect;
//				//typename function_trait<decltype(*v_fn.begin())>::template Arg<1>::type vect;
//				fn(tmp_name,vect);
//				tmp_size = vect.size();
//				const size_t nb_elem = sizeof(typename
//						std::remove_reference<decltype(vect)>::type::value_type)/sizeof(float);
//				group_to_location_and_nb_elem[tmp_name]={location,nb_elem};
//				tmp_size *= sizeof(typename std::remove_reference<decltype(vect)>::type::value_type);
//				location+=tmp_size;
//				vsize.push_back(tmp_size);
////				std::cout << tmp_size << std::endl;
//				uptr = decltype(uptr)(new unsigned char[tmp_size]);
//				memcpy(uptr.get(),vect.data(),tmp_size);
////				for(int i=0; i<24; i+=3)
////				{
////					std::cout << (*reinterpret_cast<float*>(uptr.get()+4*i))<<" ";
////					std::cout << (*reinterpret_cast<float*>(uptr.get()+4*(i+1)))<<" ";
////					std::cout << (*reinterpret_cast<float*>(uptr.get()+4*(i+2)))<<std::endl;
////				}
//				vertex.push_back(std::move(uptr));
//			}
//			create_vbo_tmp(group_to_location_and_nb_elem,vertex,vsize,location,args...);
//}
//	void add_vertex(std::function<void(std::string&,std::vector<int>)>& f)
//	{
//		std::get<0>(data).push_back(f);
//	}
//	void add_vertex(std::function<void(std::string&,std::vector<float>)>& f)
//	{
//		std::get<1>(data).push_back(f);
//	}
//	void add_vertex(std::function<void(std::string&,std::vector<glm::vec2>)>& f)
//	{
//		std::get<2>(data).push_back(f);
//	}
//	void add_vertex(std::function<void(std::string&,std::vector<glm::vec3>)>& f)
//	{
//		std::get<3>(data).push_back(f);
//	}
//	void add_vertex(std::function<void(std::string&,std::vector<glm::vec4>)>& f)
//	{
//		std::get<4>(data).push_back(f);
//	}
	template<typename T>
	void add_vertex(const std::string& group_name, const std::vector<T>& data)
	{
		GLuint tmp_size = (GLuint)data.size();
		const GLuint nb_elem = sizeof(typename
						std::remove_reference<decltype(data)>::type::value_type)/sizeof(float);
//		std::cout << __FILE__ << " " << __LINE__ << "  change the way i compute the number of elem in vec3, vec4, float ..."<<std::endl;
		group_to_location_and_nb_elem[group_name] = std::make_pair(location, nb_elem);
		tmp_size *= sizeof(typename std::remove_reference<decltype(data)>::type::value_type);//sizeof(T)
		location+=tmp_size;
		v_size_tmp.push_back(tmp_size);
		unsigned char* uptr = new unsigned char[tmp_size];
		memcpy(uptr,data.data(),tmp_size);

		vptr_data_tmp.push_back(uptr);

	}
		void create_vbo()
	{
		unsigned char* data = new unsigned char[location/sizeof(unsigned char)];
		unsigned char* ptr_data = data;
		std::vector<unsigned char*>::const_iterator ptr_vertex = vptr_data_tmp.begin();
		std::vector<std::size_t>::const_iterator ptr_size = v_size_tmp.begin();
		std::vector<unsigned char*>::const_iterator ptr_vertex_end = vptr_data_tmp.end();
		for(;ptr_vertex!=ptr_vertex_end;++ptr_vertex,++ptr_size)
		{
//			std::cout << *ptr_size << std::endl;
			memcpy(ptr_data,*ptr_vertex,*ptr_size);
			ptr_data+=*ptr_size;
		}
		if(!vbo)
			glGenBuffers(1,&vbo);
		glBindBuffer(buffer_type,vbo);
//		std::cout << location << std::endl;
//		ptr_data=data;
//				for(int i=0; i<208/4; i+=3)
//				{
//					std::cout << (*reinterpret_cast<float*>(ptr_data+4*i))<<" ";
//					std::cout << (*reinterpret_cast<float*>(ptr_data+4*(i+1)))<<" ";
//					std::cout << (*reinterpret_cast<float*>(ptr_data+4*(i+2)))<<std::endl;
//				}
		glBufferData(buffer_type,location,data,buffer_type_draw);
		delete[] data;
		std::for_each(vptr_data_tmp.begin(),vptr_data_tmp.end(),[](unsigned char* ptr){delete[] ptr;});
		vptr_data_tmp.clear();
		v_size_tmp.clear();
		location=0;
	}
	template<typename T>
	void update_one_vertex(const std::string& id_class, const std::size_t& pos, const T& data)
	{
		std::size_t offset = group_to_location_and_nb_elem[id_class].first+sizeof(T)*pos;
		glBindBuffer(buffer_type,vbo);
		glBufferSubData(buffer_type,offset,sizeof(T),&data);
	}
	template<typename T>
	void update_k_vertex(const std::string& id_class, const std::size_t& pos, const T* data, const std::size_t& k)
	{
		std::size_t offset = group_to_location_and_nb_elem[id_class].first+sizeof(T)*pos;
		glBindBuffer(buffer_type,vbo);
		glBufferSubData(buffer_type,offset,sizeof(T)*k,data);
	}
	template<typename T>
	void update_k_vertex(const std::string& id_class, const std::size_t& pos, const std::vector<T>& data)
	{
		std::size_t offset = group_to_location_and_nb_elem[id_class].first+sizeof(T)*pos;
		glBindBuffer(buffer_type,vbo);
		glBufferSubData(buffer_type,offset,sizeof(T)*data.size(),&*data.begin());
	}


	//template<typename T>
	//void add_vertex_last(T&& f)
	//{
	//	//auto a = f.target();
	//	auto a = f;
	//	//is_same
	//	//is_convertible
	////	std::cout << typeid(a).name()<<std::endl;
	//	if(std::is_same<decltype(a),decltype(*std::get<0>(data).begin())>::value)
	//	{
	//		std::get<0>(data).push_back((decltype(*std::get<0>(data).begin()))f);
	//	}
	//	else if(std::is_same<T,decltype(*std::get<1>(data).begin())>::value)
	//	{
	//		std::get<1>(data).push_back((decltype(*std::get<1>(data).begin()))f);
	//	}
	//	else if(std::is_same<T,decltype(*std::get<2>(data).begin())>::value)
//	//	else if(std::is_convertible<decltype(f),decltype(*std::get<2>(data).begin())>::value)
	//	{
	//		std::get<2>(data).push_back((decltype(*std::get<2>(data).begin()))f);
	//	}
	//	else if(std::is_same<T,decltype(*std::get<3>(data).begin())>::value)
	//	{
	//		std::get<3>(data).push_back((decltype(*std::get<3>(data).begin()))f);
	//	}
	//	else if(std::is_same<T,decltype(*std::get<4>(data).begin())>::value)
	//	{
	//		std::get<4>(data).push_back((decltype(*std::get<4>(data).begin()))f);
	//	}
	//
//	//	if(std::is_same<typename function_trait<decltype(a)>::function_type,decltype(*std::get<0>(data).begin())>::value)
//	//	{
//	//		std::get<0>(data).push_back((decltype(*std::get<0>(data).begin()))f);
//	//	}
//	//	else if(std::is_same<typename function_trait<T>::function_type,decltype(*std::get<1>(data).begin())>::value)
//	//	{
//	//		std::get<1>(data).push_back((decltype(*std::get<1>(data).begin()))f);
//	//	}
//	//	else if(std::is_same<typename function_trait<T>::function_type,decltype(*std::get<2>(data).begin())>::value)
//////		else if(std::is_convertible<decltype(f),decltype(*std::get<2>(data).begin())>::value)
//	//	{
//	//		std::get<2>(data).push_back((decltype(*std::get<2>(data).begin()))f);
//	//	}
//	//	else if(std::is_same<typename function_trait<T>::function_type,decltype(*std::get<3>(data).begin())>::value)
//	//	{
//	//		std::get<3>(data).push_back((decltype(*std::get<3>(data).begin()))f);
//	//	}
//	//	else if(std::is_same<typename function_trait<T>::function_type,decltype(*std::get<4>(data).begin())>::value)
//	//	{
//	//		std::get<4>(data).push_back((decltype(*std::get<4>(data).begin()))f);
//	//	}
	//	else
	//	{
	//		std::cerr<< __FILE__ << " " << __LINE__<<std::endl;
	//		assert(1==0);
	//	}
	//}

	//void create_vbo_last()
	//{
	//	std::vector<std::unique_ptr<unsigned char>> vertex;
	//	std::vector<size_t> vsize;
	//	size_t location(0);
	//
	//	create_vbo_tmp(group_to_location_and_nb_elem,vertex,vsize,location,std::get<0>(data),std::get<1>(data),
	//			std::get<2>(data),std::get<3>(data),std::get<4>(data));
	//
	//	unsigned char* data = new unsigned char[location/sizeof(unsigned char)];
	//	unsigned char* ptr_data = data;
	//	decltype(vertex)::const_iterator ptr_vertex = vertex.begin();
	//	decltype(vsize)::const_iterator ptr_size = vsize.begin();
	//	decltype(ptr_vertex) ptr_vertex_end = vertex.end();
	//	for(;ptr_vertex!=ptr_vertex_end;++ptr_vertex,++ptr_size)
	//	{
	//		std::cout << *ptr_size << std::endl;
	//		memcpy(ptr_data,ptr_vertex->get(),*ptr_size);
	//		ptr_data+=*ptr_size;
	//	}
	//	if(!vbo)
	//		glGenBuffers(1,&vbo);
	//	glBindBuffer(buffer_type,vbo);
//	//	std::cout << location << std::endl;
//	//	ptr_data=data;
//	//			for(int i=0; i<208/4; i+=3)
//	//			{
//	//				std::cout << (*reinterpret_cast<float*>(ptr_data+4*i))<<" ";
//	//				std::cout << (*reinterpret_cast<float*>(ptr_data+4*(i+1)))<<" ";
//	//				std::cout << (*reinterpret_cast<float*>(ptr_data+4*(i+2)))<<std::endl;
//	//			}
	//	glBufferData(buffer_type,location,data,GL_STATIC_DRAW);
	//	delete[] data;
	//	location=0;
	//}
	static void disable()
	{
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,0);
		glBindBuffer(GL_ARRAY_BUFFER,0);
	}
	// const std::pair<GLuint,GLuint>& operator[](const std::string& str)const
	//{
	//	return group_to_location_and_nb_elem.at(str);
	// }
	 const std::pair<GLuint, GLuint>* operator[](const std::string& str)const
	 {
		 const auto& a = group_to_location_and_nb_elem.find(str);
		 if (a == std::end(group_to_location_and_nb_elem))
			 return nullptr;
		 return &a->second;
	 }
	void operator()()const
	{
		bind();
	}
	inline void bind()const
	{
		glBindBuffer(buffer_type,vbo);
	}
};
class VAO;
class Shader
{
	private:
		VAO* vao;
	std::string mShaderName;
	GLenum shader_type;
	GLhandleARB mVertexHandle;
	GLhandleARB mFragmentHandle;
	GLhandleARB mGeometryHandle;
	GLhandleARB mProgramHandle;

	std::map<GLuint,std::shared_ptr<Texture>> m_textures;

	std::string loadFile(const std::string &str);
	GLhandleARB createSharedObjects(const std::string shader,
			GLenum shaderType);
	void linkShader(GLhandleARB);

	void init();

	int getVariableId(const std::string& strVariable) const;


    void printLog(GLuint object);


public:
	void bindTextures();
	Shader();
	virtual ~Shader();
	Shader(const Shader& s) = delete;
	Shader& operator=(const Shader& s) = delete;
	Shader(Shader&& s)
	{
		//std::cout << "shader move constructor" << std::endl;
		vao = s.vao;
		mShaderName = s.mShaderName;
		shader_type = s.shader_type;
		mVertexHandle = s.mVertexHandle;
		mFragmentHandle = s.mFragmentHandle;
		mGeometryHandle = s.mGeometryHandle;
		mProgramHandle = s.mProgramHandle;
		s.vao = nullptr;
		s.mShaderName = "";
		s.shader_type = 0;
		s.mVertexHandle = 0;
		s.mFragmentHandle = 0;
		s.mGeometryHandle = 0;
		s.mProgramHandle = 0;
	}
	Shader& operator=(Shader&& s)
	{
		this->~Shader();
		vao = s.vao;
		mShaderName = s.mShaderName;
		shader_type = s.shader_type;
		mVertexHandle = s.mVertexHandle;
		mFragmentHandle = s.mFragmentHandle;
		mGeometryHandle = s.mGeometryHandle;
		mProgramHandle = s.mProgramHandle;
		s.vao = nullptr;
		s.mShaderName = "";
		s.shader_type = 0;
		s.mVertexHandle = 0;
		s.mFragmentHandle = 0;
		s.mGeometryHandle = 0;
		s.mProgramHandle = 0;
		return *this;
	}
	Shader(const std::string &vertexShaderPath,
			const std::string &fragmentShaderPath);

    void loadFromFile(const std::string& vertex, const std::string& fragment);
    void loadFromMemory(const std::string& vertex, const std::string& fragment);

	void loadVertexShaderFromFile(const std::string &);
	void loadVertexShader(const std::string &);

	void loadFragmentShaderFromFile(const std::string &);
	void loadFragmentShader(const std::string &);

    void loadGeometryShaderFromFile(const std::string &shader);
    void loadGeometryShader(const std::string &shader);

    void setName(const std::string& name) {
        mShaderName = name;
    }

	void enable();
	static void disable();

	void setTexture(const std::string &uniformLocation, GLuint texture);
	void setTexture(const std::string &uniformLocation, const std::shared_ptr<Texture>& texture);
	void clear_texture();


//	template<typename T>
//	void set_uniform(const char* name, const T& val);
	//template<typename T>
	//void set_uniform(const char* name, const T& val)
	//{
	//	glBindBufferBase(GL_UNIFORM_BUFFER,)
	//	GLuint bindingPoint = 1, buffer, blockIndex;
	//	float myFloats[8] = { 1.0, 0.0, 0.0, 1.0, 0.4, 0.0, 0.0, 1.0 };
	//
	//	blockIndex = glGetUniformBlockIndex(p, "ColorBlock");
	//	glUniformBlockBinding(p, blockIndex, bindingPoint);
	//
	//	glGenBuffers(1, &buffer);
	//	glBindBuffer(GL_UNIFORM_BUFFER, buffer);
	//
	//	glBufferData(GL_UNIFORM_BUFFER, sizeof(myFloats), myFloats, GL_DYNAMIC_DRAW);
	//	glBindBufferBase(GL_UNIFORM_BUFFER, bindingPoint, buffer);
	//}
	void set_uniform(const char* name, const float& val)
	{
		glUniform1f(getVariableId(name), val);
	}
	void set_uniform(const char* name, const int& val)
	{
		glUniform1i(getVariableId(name), val);
	}
	void set_uniform(const char* name, const glm::vec2& val)
	{
		glUniform2f(getVariableId(name), val.x, val.y);
	}
	void set_uniform(const char* name, const glm::vec3& val)
	{
		glUniform3f(getVariableId(name), val.x, val.y, val.z);
	}
	void set_uniform(const char* name, const std::vector<glm::vec3>& val)
	{
		glUniform3fv(getVariableId(name), (GLsizei)val.size(), (GLfloat*)val.data());
	}
	void set_uniform(const char* name, const glm::vec4& val)
	{
		glUniform4f(getVariableId(name), val.x, val.y, val.z, val.t);
	}
	void set_uniform(const char* name, const glm::mat4& val)
	{
		glUniformMatrix4fv(getVariableId(name), 1, GL_FALSE,
			glm::value_ptr(val));
	}
/*	void ini_vao(const VBO& vbo)
	{
		if(!vao)
		{
			std::cerr << "you have to set a vao" << std::endl;
		}
		(*this)();
		vao->link_vao(mProgramHandle,vbo);
	}//*/
	void set_vao(VAO* const& ptr_vao)
	{
		vao = ptr_vao;
	}
	bool hasShaderSupport();

	GLhandleARB getProgramHandle() const;


    operator GLuint() { return mProgramHandle; }
    void operator()() {  enable();}
};

class VAO
{
	private:
		GLuint vao;
		const VBO* vbo;
		const VBO* ibo;
		Shader* shader;
		std::map<std::string, std::string> name_in_var_to_group;
	public:
		VAO() :vao(0), vbo(nullptr), ibo(nullptr), shader(nullptr){}
		VAO(Shader* const& ptr_shader) :vao(0), vbo(nullptr), ibo(nullptr), shader(ptr_shader)
		{
		}
		VAO(Shader* const& ptr_shader, const std::initializer_list<const std::pair<const std::string, const std::string>>& group) : vao(0), vbo(nullptr), ibo(nullptr), shader(ptr_shader)
		{
			for (const auto& a : group)
				name_in_var_to_group[a.first] = a.second;
		}
		VAO(Shader* const& ptr_shader, const VBO& aa_vbo, const std::initializer_list<const std::pair<const std::string, const std::string>>& group) : vao(0), vbo(nullptr), ibo(nullptr), shader(ptr_shader)
		{
			for (const auto& a : group)
				name_in_var_to_group[a.first] = a.second;
			link_vao(aa_vbo);
		}
		VAO(Shader* const& ptr_shader, const VBO& aa_vbo, const VBO& aa_ibo, const std::initializer_list<const std::pair<const std::string, const std::string>>& group) : vao(0), vbo(nullptr), ibo(nullptr), shader(ptr_shader)
		{
			for (const auto& a : group)
				name_in_var_to_group[a.first] = a.second;
			ibo = &aa_ibo;
			link_vao(aa_vbo);
		}
		~VAO()
		{
			if(vao)
			{
				//glBindVertexArray(vao);
				//for (const auto& a : name_in_var_to_group)
				//{
				//	(*vbo)();
				//	glDisableVertexAttribArray(glGetAttribLocation(shader->getProgramHandle(), a.first.c_str()));
				//}
				glBindVertexArray(0);
				glDeleteVertexArrays(1,&vao);
				vao=0;
				GLuint errCode;
				if (( errCode = glGetError()) != GL_NO_ERROR) {
					std::cerr << "VAO del: error: " << std::endl;
					// const GLubyte *errString;
					// errString = gluErrorString(errCode);
					// std::cerr<< "OpenGL Error (" << errCode << "): "<< errString << std::endl;
					if (errCode == GL_INVALID_OPERATION)  {
						std::cerr << "GL_INVALID_OPERATION is generated if a geometry shader is active and mode is incompatible with the input primitive type of the geometry shader in the currently installed program object." << std::endl
							<< "GL_INVALID_OPERATION is generated if a non-zero buffer object name is bound to an enabled array or the element array and the buffer object's data store is currently mapped." << std::endl;
						//         exit(1);
					}
				}
			}
			GLuint errCode;
			if ((errCode = glGetError()) != GL_NO_ERROR) {
				std::cerr << "VAO DESTRUCTOR: error: " << std::endl;
				// const GLubyte *errString;
				// errString = gluErrorString(errCode);
				// std::cerr<< "OpenGL Error (" << errCode << "): "<< errString << std::endl;
				if (errCode == GL_INVALID_OPERATION)  {
					std::cerr << "GL_INVALID_OPERATION is generated if a geometry shader is active and mode is incompatible with the input primitive type of the geometry shader in the currently installed program object." << std::endl
						<< "GL_INVALID_OPERATION is generated if a non-zero buffer object name is bound to an enabled array or the element array and the buffer object's data store is currently mapped." << std::endl;
					//         exit(1);
				}
			}
		}
		void set_shader(Shader* const& ptr_shader)
		{
			shader=ptr_shader;
		}
	void add_group(const std::string& var_name, const std::string& group_name)
	{
		name_in_var_to_group[var_name]=group_name;
	}
	void set_ibo(const VBO& aa_ibo)
	{
		ibo=&aa_ibo;
	}
	//void link_vao(const GLuint& program_handler, const VBO& aa_vbo)
	void link_vao(const VBO& aa_vbo)
	{
		if (!shader)
		{
			std::cout << "you have to set a shader" << std::endl;
			exit(EXIT_FAILURE);
		}
		vbo = &aa_vbo;
		re_link_vao();
	}
	inline Shader* get_shader()
	{
		return shader;
	}
	void re_link_vao()
	{
		GLuint errCode;
		if ((errCode = glGetError()) != GL_NO_ERROR) {
			std::cerr << "VAO link_ini: error: " << errCode<<std::endl;
			if (errCode == GL_INVALID_OPERATION)  {
				std::cerr << "GL_INVALID_OPERATION" << std::endl;
			}
		}
		if (!vao)
		{
			glGenVertexArrays(1, &vao);
		}
		const GLuint program_handler = shader->getProgramHandle();
		glBindVertexArray(vao);
		GLuint vertex_loc;
		if ((errCode = glGetError()) != GL_NO_ERROR) {
			std::cerr << "ERROR: error " << __LINE__ << ": " << errCode << std::endl;
		}
	//	std::cout << "ini vao" << std::endl;
		for(const auto& a : name_in_var_to_group)
		{
			vertex_loc = glGetAttribLocation(program_handler, a.first.c_str());
			//std::cout << "vert loc: " << vertex_loc <<" " << a.first.c_str() << std::endl;
			if ((errCode = glGetError()) != GL_NO_ERROR) {
				std::cerr << "ERROR: error " << __LINE__ << ": " << errCode << "   " << a.first.c_str() << std::endl;
			}
			//std::cout << vertex_loc<<std::endl;
			(*vbo)();
			glEnableVertexAttribArray(vertex_loc);
			if ((errCode = glGetError()) != GL_NO_ERROR) {
				std::cerr << "ERROR: error " << __LINE__ << ": " << errCode << std::endl;
			}
			const std::pair<GLuint, GLuint>* vbo_loc_nb_elem = (*vbo)[a.second];
			if (vbo_loc_nb_elem)
			{
				const std::pair<GLuint, GLuint>& vbo_loc_nb_elem_ = *vbo_loc_nb_elem;
				glVertexAttribPointer(vertex_loc, vbo_loc_nb_elem_.second, GL_FLOAT, 0, 0, BUFFER_OFFSET(vbo_loc_nb_elem_.first));
				if ((errCode = glGetError()) != GL_NO_ERROR) {
					std::cerr << "ERROR: error " << __LINE__ << ": " << errCode << std::endl;
				}
			}
			else
			{
				std::cout << a.second << " is not present into the vbo" << std::endl;
			}
			if ((errCode = glGetError()) != GL_NO_ERROR) {
				std::cerr << "ERROR: error " << __LINE__ << ": " << errCode << std::endl;
			}
				//const std::pair<GLuint, GLuint>& vbo_loc_nb_elem = *(*vbo)[a.second];
				//		std::cout << vbo_loc_nb_elem.second << " " << vbo_loc_nb_elem.first<<std::endl;
				
		}
		if ((errCode = glGetError()) != GL_NO_ERROR) {
			std::cerr << "ERROR: error " << __LINE__ << ": " << errCode << std::endl;
		}
	//	std::cout << "vao loaded" << std::endl;
		VBO::disable();
		glBindVertexArray(0);
		if ((errCode = glGetError()) != GL_NO_ERROR) {
			std::cerr << "ERROR: error " << __LINE__ << ": " << errCode << std::endl;
		}
	}
	void unlink_vao()
	{
		const GLuint program_handler = shader->getProgramHandle();
		glBindVertexArray(vao);
		(*vbo)();
		for(const auto& a : name_in_var_to_group)
		{
			glDisableVertexAttribArray(glGetAttribLocation(program_handler, a.first.c_str()));
		}
		VBO::disable();
		glBindVertexArray(0);
	}
	void operator()()
	{
		if(ibo)
			(*ibo)();
		if(vao)
			glBindVertexArray(vao);
		else if(vbo)
			(*vbo)();
	}
	static void disable()
	{
		glBindVertexArray(0);
		VBO::disable();
	}

};
#endif


