#include <QtGui/QImage>
#include "texture_qt.h"

Texture_qt::Texture_qt():base_texture()
{
}

Texture_qt::Texture_qt(const std::string& path):base_texture()
{
	loadTexture(path);
}

Texture_qt::Texture_qt(const GLuint id):base_texture(id)
{
}

Texture_qt::~Texture_qt()
{
}
Texture_qt::Texture_qt(const glm::vec2& size):base_texture(size)
{
}

bool Texture_qt::save_texture(const std::string& name, unsigned char* data, const int& w, const int& h)
{
	return save_data(name,data,w,h);
}
bool Texture_qt::save_data(const std::string& name, unsigned char* data, const int& w, const int& h)
{
	//unsigned char tmp;
	//in : RGBA
	//out: ARGB // 0AARRGGBB // BGRA
	//for(int i=0,i_end(w*h*4); i!=i_end;i+=4)
	//{
	//	tmp=data[i+3];
	//	data[i+3]=data[i+2];
	//	data[i+2]=data[i+1];
	//	data[i+1]=data[i];
	//	data[i]=tmp;
	//	tmp=data[i];
	//	data[i]=data[i+1];
	//	data[i+1]=data[i+2];
	//	data[i+2]=data[i+3];
	//	data[i+3]=tmp;
	//}
//	QImage img(data, w,h,QImage::Format_ARGB32);
	//QImage img(data, w,h,QImage::Format_RGBA8888);
	std::cout << "aa"<<std::endl;
	QImage img(data, w,h,QImage::Format_ARGB32);
	std::cout << "add"<<std::endl;
//	img.loadFromData(data,w*h*4
	img.mirrored().save(QString(name.c_str()));
	return true;
}
bool Texture_qt::save_data_mono(const std::string& name, unsigned char* data, const int& w, const int& h)
{
	unsigned char tmp;
	unsigned char* data2 = new unsigned char[w*h*4];
	int i4;
	for(int i=0,i_end(w*h); i!=i_end;i++)
	{
		tmp=data[i];
		i4 = i<<2;
		data2[i4]=tmp;
		data2[i4+1]=tmp;
		data2[i4+2]=tmp;
		data2[i4+3]=tmp;
	}
	std::cout << "aa"<<std::endl;
	QImage img(data2, w,h,QImage::Format_RGB32);
	std::cout << "add"<<std::endl;
	img.mirrored().save(QString(name.c_str()));
	//QImage imgx = img.transformed(QMatrix(1,-1,1,-1,0,0));
	//QImage imgy = img.transformed(QMatrix(1,1,-1,-1,0,0));
	//imgx.mirrored().save(QString((name+"x.png").c_str()));
	//imgy.mirrored().save(QString((name+"y.png").c_str()));
	delete[] data2;
	return true;
}
bool Texture_qt::loadTexture(const std::string &path)
{
	mName = path;

	QImage img;
	try
	{
		img.load(QString(path.c_str()));
		//img = img.convertToFormat(QImage::Format_RGBA8888);
		img = img.convertToFormat(QImage::Format_RGB888);
	}
	catch(...)
	{
		throw new  std::runtime_error( "Error: Image " + path + " loading failed!");
	}
	return base_texture::loadTexture(img.bits(),img.size().width(),img.size().height(),path,GL_RGB);
}
