#include"main.h"
#include"cost_empty_sample.h"
#include"gui_empty_sample.h"
int main(int argc, char** argv)
{
	QApplication app(argc, argv);
	if (!QGLFormat::hasOpenGL()) {
		QMessageBox::critical(NULL, "Attention", QObject::tr("desole pas d'OpenGL !"));
		return -1;
	}
	app.setApplicationName("Empty demo for Delaunay Point Process");
	delaunay_point_process_gui<
		Cost_vertices_empty_sample,
		Cost_edges_empty_sample,
		Cost_faces_empty_sample,
		ini_data_cost_empty_sample,
		gui_rendering_empty_sample> mon_dpp;
	mon_dpp.mainWin.resize(1024, 1024);
	mon_dpp.mainWin.show();
	//mainWin.setVisible(true);
	return app.exec();
}