#include"main.h"
#include"cost_image_compression.h"

int main(int argc, char** argv)
{
	DPP::Parameters parameters;
	const std::string base_name = "bin_fleur";
	const std::string full_name = "C:\\data\\data_3\\bin_fleur.png";
	delaunay_point_process<
		Cost_vertices_ImageCompression,
		Cost_edges_ImageCompression,
		Cost_faces_ImageCompression,
		ini_data_cost_image_compression, glm::vec3> mon_dpp(parameters, base_name, full_name);
	return EXIT_SUCCESS;
}