#include"main.h"
#include"cost_line_network_extraction.h"
#include"gui_line_network_extraction.h"


int main(int argc, char** argv)
{
	QApplication app(argc, argv);
	if (!QGLFormat::hasOpenGL()) {
		QMessageBox::critical(NULL, "Attention", QObject::tr("desole pas d'OpenGL !"));
		return -1;
	}
	app.setApplicationName("Line network extraction by Delaunay Point Process");
	delaunay_point_process_gui<
		Cost_vertices_line_network_extraction,
		Cost_edges_line_network_extraction,
		Cost_faces_line_network_extraction,
		ini_data_cost_line_network_extraction,
		gui_rendering_line_network_extraction> mon_dpp;
	mon_dpp.mainWin.resize(1024, 1024);
	mon_dpp.mainWin.show();
	//mainWin.setVisible(true);
	return app.exec();
}