#include"main.h"
#include"cost_object_contouring.h"
#include"gui_object_contouring.h"
int main(int argc, char** argv)
{
	QApplication app(argc, argv);
	if (!QGLFormat::hasOpenGL()) {
		QMessageBox::critical(NULL, "Attention", QObject::tr("desole pas d'OpenGL !"));
		return -1;
	}
	app.setApplicationName("Object contouring by Delaunay Point Process");
	delaunay_point_process_gui<
		Cost_vertices_object_contouring,
		Cost_edges_object_contouring,
		Cost_faces_object_contouring,
		ini_data_cost_object_contouring,
		gui_rendering_object_contouring,
		labelObjectContouring> mon_dpp;
	mon_dpp.mainWin.resize(1024, 1024);
	mon_dpp.mainWin.show();
	//mainWin.setVisible(true);
	return app.exec();
}