#include "image_tex.h"

//Image_tex::Image_tex()
//{
//}
//Image_tex::Image_tex(VAO* ptr_vao, const char* texture_file_name) :object(ptr_vao), tex_name(texture_file_name)
//{
//	if (texture_file_name != "")
//		set_texture("texture", std::shared_ptr<Texture>(new Texture_qt(texture_file_name)));
//}
//Image_tex::~Image_tex()
//{
////	glDeleteBuffers(1,&buffer_cube);
//}
//inline void create_vbo_final(GLuint& buffer_cube, void* data, size_t size)
//{
//	//Generation d'un nom de VBO
//    glGenBuffers(1, &buffer_cube);
//
//    //Liaison du VBO
//    glBindBuffer(GL_ARRAY_BUFFER, buffer_cube);
//
//    //Ecriture des donnes dans le VBO
//    glBufferData(GL_ARRAY_BUFFER, size, data, GL_STATIC_DRAW);
//}
//inline void create_vbo_tmp(std::vector<const void*>&, std::vector<size_t>&)
//{
//}
//template<typename T, typename... Args>
//inline void create_vbo_tmp(std::vector<const void*>& v, std::vector<size_t>& s, const std::vector<T>& vect, const Args&... args)
//{
//	v.push_back(vect.data());
//	s.push_back(vect.size()*sizeof(T));
//	create_vbo_tmp(v,s,args...);
//}
//template<typename... Args>
//inline void create_vbo(GLuint& buffer_cube, const Args&... args)
//{
//	std::vector<const void*> v;
//	std::vector<size_t> s;
//	create_vbo_tmp(v,s,args...);
//	size_t size(0);
//	for(const auto& a : s)
//		size+=a;
//	unsigned char* data = new unsigned char[size];
//
//	unsigned char* ptr_data = data;
//	auto ptr_size = s.data();
//	auto ptr_v = v.data();
//	const size_t i_max = s.size();
//	for(int i=0; i<i_max; ++i)
//	{
//		const size_t& local_size = *ptr_size;
//		memcpy(ptr_data, *ptr_v, local_size);
//		ptr_data+=local_size;
//		++ptr_size;
//		++ptr_v;
//	}
//	create_vbo_final(buffer_cube, data, size);
//	delete[] data;
//}
//void Cube_tex::createVBO()
//{
//	std::vector<vec3> vertex_data;
//	ini_vertex_data(vertex_data);
//	std::vector<vec3> color_data;
//	ini_color_data(color_data);
//	std::vector<vec3> normal_data;
//	ini_normal_data(normal_data);
//	std::vector<vec2> tex_coord_data;
//	ini_tex_data(tex_coord_data);
//    
//
//
//	create_vbo(buffer_cube, vertex_data, color_data, normal_data, tex_coord_data);
//}

std::function<void (std::string&, std::vector<glm::vec3>&)> Image_tex::ini_default_vertex_data = [](std::string& name, std::vector<glm::vec3>& vertex_data)

{
	name = "vertex_img";
	glm::vec3 A(-1,-1,0);
	glm::vec3 B(1,-1,0);
	glm::vec3 C(1,1,0);
	glm::vec3 D(-1,1,0);

	glm::vec3 tmp[4] = {
        A,B,C,D
	};
	vertex_data.clear();
	vertex_data.reserve(4);
	std::for_each(std::begin(tmp),std::end(tmp),[&vertex_data](const glm::vec3& vec){vertex_data.push_back(vec);});	
};

std::function<void (std::string&, std::vector<glm::vec2>&)> Image_tex::ini_default_tex_data = [](std::string& name, std::vector<glm::vec2>& tex_coord_data)
{
	name="tex_img";
	glm::vec2 tex_00(0,0);
	glm::vec2 tex_10(1,0);
	glm::vec2 tex_01(0,1);
	glm::vec2 tex_11(1,1);
	glm::vec2 tmp[4] = 
	{
		tex_00, tex_10, tex_11, tex_01
	};
	tex_coord_data.clear();
	tex_coord_data.reserve(4);
	std::for_each(std::begin(tmp),std::end(tmp),[&tex_coord_data](const glm::vec2& vec){tex_coord_data.push_back(vec);});
};
//void Image_tex::draw_2(const glm::mat4& scene)const
//{
//	 size_t i = 0;
//	 glEnable(GL_TEXTURE_2D);
//	 shader->setTexture(tex_name,texture);
//	 glDrawArrays(GL_QUADS, 0, 4);
//	 Shader::disable();
//}
void Image_tex::set_texture(const std::string& name, const std::shared_ptr<Texture>& i)
{
	texture=i;
	tex_name = name;
}

